{------------------------------------------------------------------------------
                         U C I B L E . P A S

Cette unit contient les routines de gestion de la cible. Ainsi la cible peut tre
considre comme un objet instanci par les feuilles de jeu et d'tion
-------------------------------------------------------------------------------}
unit UCible;

interface
uses extctrls, classes;

type TCible = class(TImage)
    procedure UserClick(Sender : TObject);
    procedure UserMouseMove(Sender : TObject; Shift : TShiftState; X, Y : integer);
    procedure ChangeSorte(Sorte : byte);
    constructor Create(AOwner : TComponent); override;
  private
    FSorte : byte;
    FEdition : boolean;
  published
    property Sorte : byte read FSorte write ChangeSorte;
// Sorte : pour savoir le type de cible (pas utilis pour le moment
    property Edition : boolean read FEdition write FEdition;
// Edition : pour savoir si l'objet est utilis dans lune dition de niveau
  end;


implementation
uses Palette, divers, Sysutils;

procedure TCible.userClick(Sender : TObject);
begin
// si on clique et que le parent est en gomme alors on disparait
  inherited;
  if Edition then
    if (parent as TFeuilleJeu).mode = mdGomme then begin
      (parent as TFeuilleJeu).EffaceLaser;
      frmPalette.tbtCible.enabled := true;
      visible := false;
    end;
end;

procedure TCible.UserMouseMove(Sender : TObject; Shift : TShiftState; X, Y : integer);
begin
// dplace l'objet
  if (parent as TFeuilleJeu).grille then begin
    X := (X div 10) * 10;
    Y := (Y div 10) * 10;
  end;
  if Edition and (shift = [ssleft]) then begin
    (parent as TFeuilleJeu).EffaceLaser;
    top := top + Y - round(height/2);
    left := left + X - round(width/2);
    (parent as TFeuilleJeu).modifie := true;
  end;
  inherited;
end;

constructor TCible.Create(AOwner : TComponent);
begin
// cration de l'objet
  inherited;

  transparent := false;
  autosize := true;
  FSorte := 0;
  FEdition := false;
  OnMouseMove := UserMouseMove;
  OnClick := UserClick;
end;

procedure TCible.ChangeSorte(Sorte : byte);
begin
// mise  jour de l'image lors du changement de sorte
  FSorte := Sorte;
  Picture.loadfromfile(RepAct+'\images\cible'+inttostr(1+Fsorte)+'.bmp');
end;



end.
