{------------------------------------------------------------------------------
                         U M I R O I R . P A S

Cette unit contient les routines de gestion du miroir. Ainsi le miroir peut tre
considr comme un objet instanci par les feuilles de jeu et d'tion
-------------------------------------------------------------------------------}
unit UMiroir;

interface
uses extctrls, classes;

type
  TMiroir = class(TImage)
    procedure MAJAngle(NouvAngle : integer);
    procedure Dessine;
    procedure UserClick(Sender : TObject);
    procedure UMouseMove(Sender : TObject; Shift : TShiftState; X, Y : integer);
    constructor Create(AOwner : TCOmponent); override;
  private
    FAngle   : integer;                                      // angle du laser
    FEdition : boolean;
  published
    property Angle : integer read FAngle write MAJAngle;
    property Edition : boolean read FEdition write FEdition;
  end;


implementation

uses SysUtils, graphics, divers, controls, Palette, principal;


procedure TMiroir.UserClick(Sender : TObject);
begin
  inherited;
// disparait s'il le faut
  if Edition then
    if (parent as TFeuilleJeu).mode = mdGomme then begin
      visible := false;
    end;
end;

procedure TMiroir.MAJAngle(NouvAngle : integer);
var binf,
    bsup,
    mil   : integer;
    proprio : TfeuilleJeu;
begin
// met  jour l'angle du laser en fontion du nouvel angle. Cette mise  jour est plus
// complexe qu'une simple affectation puisqu'il ne faut pas que le miroir tourne
// alatoirement 
  proprio := parent as TFeuilleJeu;

  with proprio do begin
    if (angle - NouvAngle) mod 180 <> 0 then begin
      modifie := false;
      if (laser <> nil) and (cible <> nil) then
        TraceLaser(proprio, laser.left+trunc(laser.width/2),laser.top+trunc(laser.height/2), laser.angle, false);

      case angle of
        0..89 :    begin
                     binf := 270;
                     bsup := 90;
                     mil := 0;
                   end;
        90..270 :  begin
                     binf := -90;
                     bsup := 90;
                     mil := 180;
                   end;
        271..359 : begin
                     binf := -90;
                     bsup := -270;
                     mil := 0;
                   end;
      end;

      if ((nouvangle < angle + bsup) and (nouvangle >= mil)) or ((nouvangle > angle + binf) and (nouvangle < 360 - mil)) then
        Fangle := nouvangle
      else
        Fangle := nouvangle + 180;

      Fangle := Fangle mod 360;
      dessine;
      modifie := true;
    end;
  end;


end;

procedure TMIroir.Dessine;
var x1,
    y1,
    x2,
    y2    : integer;
begin
// redessine le miroir. ceci est plus facile que de charger une image par position
// Il en aurait alors fallut 72 !
  with canvas do begin
    pen.color := $256AC7;
    Brush.color := clblack;
    pen.width := 1;
    Ellipse(0,0,width, height);
    pen.color := $315d99;
    Brush.color := $315d99;
    Ellipse(trunc(width/2)-4,trunc(height/2)-4,trunc(width/2)+4, trunc(height/2)+4);
    pen.color := $9a2c4b;
    pen.width := 3;
    x1 := trunc(width/2) - round(18 * cos(angle*pi/180) + sin (angle*pi/180)/2);
    y1 := trunc(height/2) + round(18 * sin(angle*pi/180) - cos (angle*pi/180)/2);
    x2 := trunc(width/2) + round(18 * cos(angle*pi/180) - sin (angle*pi/180)/2);
    y2 := trunc(height/2) - round(18 * sin(angle*pi/180) + cos (angle*pi/180)/2);
    Moveto(x1,y1);
    LineTo(x2,y2);
    pen.color := clWhite;
    pen.width := 1;
    x1 := trunc(width/2) - round(18 * cos(angle*pi/180) - sin (angle*pi/180));
    y1 := trunc(height/2) + round(18 * sin(angle*pi/180) + cos (angle*pi/180));
    x2 := trunc(width/2) + round(18 * cos(angle*pi/180) + sin (angle*pi/180));
    y2 := trunc(height/2) - round(18 * sin(angle*pi/180) - cos (angle*pi/180));
    Moveto(x1,y1);
    LineTo(x2,y2);
  end;
  if parent = frmLaseroid then
    if frmLaseroid.mnuBruitages.checked then begin
      frmLaseroid.playermiroir.play;
    end;

end;

procedure TMiroir.UMouseMove(Sender : TObject; Shift : TShiftState; X, Y : integer);
var NouvAngle : extended;
begin
// Gre les dplacements au dessus du miroir : Si on dite alors si le bouton est
// enfonc, il faut dplacer le miroir. Si en plus, la touceh Ctrl est enfonce
// alors on fait tourner. Sinon si on n'est pas en dtion, on fait tourner le miroir
  (parent as TFeuilleJeu).modifie := false;
  if Edition then begin
    if (shift = [ssCtrl]) or (shift = [ssCtrl, ssLeft])then
      cursor := crTrnMir
    else
      cursor := crDefault;
    if shift = [ssLeft, ssCtrl] then begin
      NouvAngle := -arctan( (Y-(height/2))/(X-(width/2)) );
      if (X-(width/2))<0 then
        NouvAngle := NouvAngle+pi;
      if (NouvAngle < 0) then
        NouvAngle := NouvAngle+2*pi;
      NouvAngle := trunc(NouvAngle* 180 / pi);
      NouvAngle := trunc ((NouvAngle+2.5)/5)*5;
      if NouvAngle = 360 then
        NouvAngle := 0;
      angle := round(NouvAngle);
    end
    else begin
      if (parent as TFeuilleJeu).Grille then begin
        X := (X div 10) * 10;
        Y := (Y div 10) * 10;
      end;
      if shift = [ssLeft] then begin
        (parent as TfeuilleJeu).EffaceLaser;
        top := top + Y - round(height/2);
        left := left + X - round(width/2);
      end;
    end;
  end
  else
    if shift = [ssleft] then begin
      NouvAngle := -arctan( (Y-(height/2))/(X-(width/2)) );
      if (X-(width/2))<0 then
        NouvAngle := NouvAngle+pi;
      if (NouvAngle < 0) then
        NouvAngle := NouvAngle+2*pi;
      NouvAngle := trunc(NouvAngle* 180 / pi);
      NouvAngle := trunc ((NouvAngle+2.5)/5)*5;
      if NouvAngle = 360 then
        NouvAngle := 0;
      angle := round(NouvAngle);
    end;
  (parent as TFeuilleJeu).modifie := true;
  inherited;
end;

constructor TMiroir.Create(AOwner : TComponent);
begin
  inherited;
// initialise le miroir
  onmousemove := umousemove;
  OnClick := userclick;
  canvas.Brush.color := clblack;
  canvas.FloodFill(0,0,clWhite,fsSurface);  // tout le canevas noir
  transparent := false;
  width := 41;
  height := 41;
  Fangle := 1;
  FEdition := false;

  end;

end.
